%Format: paramid41.m
%Use   : This script can be used to create ARX, ARMAX and BJ models for the 
%        pre-loaded data listed in the code
%Note  : This function also stores the parameters for the 30 data sets and
%        averages them
%Ver D has fit analysis - SSR, chi squared
outlist=['d4101'; 'd4102'; 'd4103'; 'd4104'; 'd4105'; 'd4106'; 'd4107'; 'd4108'; 'd4109'; 'd4110'; 'd4111'; 'd4112'; 'd4113'; 'd4114'; 'd4115'; ...
        'd4116'; 'd4117'; 'd4118'; 'd4119'; 'd4120'; 'd4121'; 'd4122'; 'd4123'; 'd4124'; 'd4125'; 'd4126'; 'd4127'; 'd4128'; 'd4129'; 'd4130']; 
inlist=['d001'; 'd002'; 'd003'; 'd004'; 'd005'; 'd006'; 'd007'; 'd008'; 'd009'; 'd010'; 'd011'; 'd012'; 'd013'; 'd014'; 'd015'; ...
        'd016'; 'd017'; 'd018'; 'd019'; 'd020'; 'd021'; 'd022'; 'd023'; 'd024'; 'd025'; 'd026'; 'd027'; 'd028'; 'd029'; 'd030']; 

f=60;
repeat=0;
while repeat~=2
    model=menu('Select the model structure','ARX','ARMAX','Box-Jenkins');
%    orders=[3 2 2 1];
    if (exist('orders')==0)
    switch(model)
        case 1
            orders=input('Enter the ARX orders [na nb nk] : '); 
        case 2
            orders=input('Enter the ARMAX orders [na nb nc nk] : '); 
        case 3
            orders=input('Enter the Box-Jenkins orders [nb nc nd nf nk] : '); 
        end
    end
    fprintf('Generating models ... ')
    Asum=0;
    Bsum=0;
    Csum=0;
    Dsum=0;
    for i=1:size(outlist,1)
%    for i=25:25       %Just perform analysis on test #25 [TM -02/10/02]
        fprintf([' ' num2str(i)]);
        %Filtering
        eval(['temp2=' outlist(i,:) ';'])           %Replace original data with filtered data
        border=4;
        bfreq=.2;
        [butterB,butterA]=butter(border,bfreq);
%        eval([outlist(i,:) '=filtfilt(butterB,butterA,temp2);'])
        eval(['d=mean(d41' num2str(i,'%02d') ');'])
        eval(['data' num2str(i,'%02d') '=iddata(' outlist(i,:) '''-d,' inlist(i,:) '''-100,1/f);'])
        switch(model)
        case 1
            eval(['marx' num2str(i,'%02d') '=arx(data' num2str(i,'%02d') ',orders);'])
            eval(['Asum=Asum+marx' num2str(i,'%02d') '.A;'])
            eval(['Bsum=Bsum+marx' num2str(i,'%02d') '.B;'])
        case 2
            eval(['marmax' num2str(i,'%02d') '=armax(data' num2str(i,'%02d') ',orders);'])
            eval(['Asum=Asum+marmax' num2str(i,'%02d') '.A;'])
            eval(['Bsum=Bsum+marmax' num2str(i,'%02d') '.B;'])
            eval(['Csum=Csum+marmax' num2str(i,'%02d') '.C;'])
        case 3
            eval(['mbj' num2str(i,'%02d') '=bj(data' num2str(i,'%02d') ',orders);'])
            eval(['Asum=Asum+mbj' num2str(i,'%02d') '.A;'])
            eval(['Bsum=Bsum+mbj' num2str(i,'%02d') '.B;'])
            eval(['Csum=Csum+mbj' num2str(i,'%02d') '.C;'])
            eval(['Dsum=Dsum+mbj' num2str(i,'%02d') '.D;'])
        end
        eval([outlist(i,:) '=temp2;'])           %Replace original data with filtered data
    end
    fprintf('\n');
    %Average the parameter values
    avgA=Asum/size(outlist,1);
    avgB=Bsum/size(outlist,1);
    avgC=Csum/size(outlist,1);
    avgD=Dsum/size(outlist,1);
    clear Asum Bsum Csum Dsum
    
    clear x2 SSR
    fprintf('(NOT) Plotting ... ')
    t=0:1/60:256/60-1/60;
%    testno=menu('Select the trial number','1','2','3','4','5','6');
    for i=1:size(outlist,1)
%    for i=25:25       %Just perform analysis on test #25 [TM -02/10/02]
        fprintf([' ' num2str(i)]);
        switch(model)
        case 1
            eval(['tfmarx' num2str(i,'%02d') '=tf(marx' num2str(i,'%02d') ');'])
            eval(['y' num2str(i) '=lsim(tfmarx' num2str(i,'%02d') '(1),' inlist(i,:) '-100,t);'])
        case 2
            eval(['tfmarmax' num2str(i,'%02d') '=tf(marmax' num2str(i,'%02d') ');'])
            eval(['y' num2str(i) '=lsim(tfmarmax' num2str(i,'%02d') '(1),' inlist(i,:) '-100,t);'])
        case 3
            eval(['tfmbj' num2str(i,'%02d') '=tf(mbj' num2str(i,'%02d') ');'])
            eval(['y' num2str(i) '=lsim(tfmbj' num2str(i,'%02d') '(1),' inlist(i,:) '-100,t);'])
        end
       figure,hold on
        eval(['d=mean(d41' num2str(i,'%02d') ');'])
       eval(['plot(t,' outlist(i,:) '-d,''g'');'])
       eval(['plot(t,y' num2str(i) ',''r:'');'])
        eval(['x2(i)=sum((y' num2str(i) '''-(d41' num2str(i,'%02d') '-d)).^2./(d41' num2str(i,'%02d') '-d));'])
        eval(['SSR(i)=sum((y' num2str(i) '''-(d41' num2str(i,'%02d') '-d)).^2);']);
        switch(model)
        case 1
            title(['ARX Model # ' num2str(i,'%02d') ' with orders [ ' num2str(orders(1)) ' ' num2str(orders(2)) ' ' num2str(orders(3)) '])'])
            legend('Experiment','ARX')
        case 2
            title(['ARMAX Model # ' num2str(i,'%02d') ' with orders [ ' num2str(orders(1)) ' ' num2str(orders(2)) ' ' num2str(orders(3)) ' ' num2str(orders(4)) '])'])
            legend('Experiment','ARMAX')
        case 3
            title(['Box-Jenkins Model # ' num2str(i,'%02d') ' with orders [ ' num2str(orders(1)) ' ' num2str(orders(2)) ' ' num2str(orders(3)) ' ' num2str(orders(4)) ' ' num2str(orders(5)) '])'])
            legend('Experiment','Box-Jenkins')
        end
    end
    fprintf('\n');
    fprintf(['Chi^2 : ' num2str(mean(abs(x2))) '\t(STD : ' num2str(std(abs(x2))) ')\n'])
    fprintf(['SSR   : ' num2str(mean(SSR)) '\t(STD : ' num2str(std(SSR)) ')\n'])
    fprintf(['sqSSR : ' num2str(sqrt(mean(SSR))) '\n'])
    repeat=menu('Repeat?','Yes','No');
    mo=model;
    clear orders i model
end
if menu('Close All?','Yes','No')==1
    close all
end

clear inlist outlist f repeat i t

%Create a mean MARMAX model [02/13/03 -TM]
%Cant seem to get Ts to input correctly in IDPOLY
%meanmarmax=idpoly(avgA,avgB,avgC,1,1,.0167);

%break  %Stop script here, unless additional coding is desired, dont remember what this was [TM -02/10/02]
clear A B C D F rA rB
%??? - MOve to convenient variables - 02/24/03
switch(mo)
case 1
    for i=1:30
        eval(['A(i,:)=marx' num2str(i,'%02d') '.A;'])
        eval(['B(i,:)=marx' num2str(i,'%02d') '.B;'])
    end
    A(31,:)=mean(A,1);
    B(31,:)=mean(B,1);
case 2
    for i=1:30
        eval(['A(i,:)=marmax' num2str(i,'%02d') '.A;'])
        eval(['B(i,:)=marmax' num2str(i,'%02d') '.B;'])
        eval(['C(i,:)=marmax' num2str(i,'%02d') '.C;'])
        rA(i,:)=roots(A(i,:))';
        rB(i,:)=roots(B(i,:))';
    end
    A(31,:)=mean(A,1);
    B(31,:)=mean(B,1);
    C(31,:)=mean(C,1);
    rA(31,:)=mean(rA,1);
    rB(31,:)=mean(rB,1);
case 3
    for i=1:30
        eval(['B(i,:)=mbj' num2str(i,'%02d') '.B;'])
        eval(['C(i,:)=mbj' num2str(i,'%02d') '.C;'])
        eval(['D(i,:)=mbj' num2str(i,'%02d') '.D;'])    
        eval(['F(i,:)=mbj' num2str(i,'%02d') '.F;'])
    end
    B(31,:)=mean(B,1);
    C(31,:)=mean(C,1);
    D(31,:)=mean(D,1);
    F(31,:)=mean(F,1);
end
clear mo i